Option Public
Use "ErrorHandlerLib"
Const CF_TEXT = &H01
Const SRCCOPY = &HCC0020

Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (Byval lpString1 As Long, Byval lpString2 As String) As Long
Declare Function lstrcpy1 Lib "kernel32" Alias "lstrcpyA"(Byval lpString1 As String, Byval lpString2 As Any) As Long
Declare Function OpenClipboard Lib "user32" Alias "OpenClipboard" (Byval hwnd As Long) As Long
Declare Function CloseClipboard Lib "user32" Alias "CloseClipboard" () As Long
Declare Function EmptyClipboard Lib "user32" Alias "EmptyClipboard" () As Long
Declare Function GetClipboardData Lib "user32" Alias "GetClipboardData" (Byval wFormat As Long) As Long
Declare Function SetClipboardData Lib "user32" Alias "SetClipboardData" (Byval wFormat As Long, Byval hMem As Long) As Long
Declare Function IsClipboardFormatAvailable Lib "user32" Alias "IsClipboardFormatAvailable" (Byval wFormat As Long) As Long
Declare Function GlobalAlloc Lib "kernel32" Alias "GlobalAlloc" (Byval wFlags As Long, Byval dwBytes As Long) As Long
Declare Function GlobalLock Lib "kernel32" Alias "GlobalLock" (Byval hMem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" Alias "GlobalUnlock" (Byval hMem As Long) As Long
Declare Function GlobalSize Lib "kernel32" Alias "GlobalSize" (Byval hMem As Long) As Long
Declare Function NEMGetCurrentSubprogramWindow Lib "nnotesws.dll" () As Long
Declare Function NEMStopSubprogramWindow Lib "nnotesws.dll" (Byval wHandle As Long) As Integer

Function GetClipBoardText() As String
	GetClipBoardText = ""
	
	Dim hClipMemory As Long
	Dim lpClipMemory As Long
	Dim MyString As String
	Dim TrimmedString As String
	Dim RetVal As Long
	Dim returnInt As Integer
	Const CF_TEXT = 1
	Const MAXSIZE = 30000
	
	If OpenClipboard(0&) = 0 Then
		Msgbox "Cannot open Clipboard. Another application may have it open"
		Exit Function
	End If
	hClipMemory = GetClipboardData(CF_TEXT)
	
	If hClipMemory = 0 Then
		Print "Could not allocate memory."
		Goto ReadyToExit
	End If
	
	lpClipMemory = GlobalLock(hClipMemory)
	
	If lpClipMemory <> 0 Then
		MyString = Space$(MAXSIZE)
		RetVal = lstrcpy1(MyString, lpClipMemory)
		RetVal = GlobalUnlock(hClipMemory)
		TrimmedString = Trim(MyString)
	Else
		Print "Could not lock memory to copy string from."
	End If
	
ReadyToExit:
	RetVal = CloseClipboard()
	GetClipBoardText = TrimmedString
End Function

Sub SetClipboardText(text As String)
	Dim hwnd As Long
	Dim hGlobalMemory As Long
	Dim lpGlobalMemory As Long
	Dim ret As Variant
	
	hwnd = NEMGetCurrentSubProgramWindow()
	If hwnd Then
		hGlobalMemory = GlobalAlloc(Clng(GMEM_MOVEABLE Or GMEM_ZEROINIT), Clng(Len(text)+1))
		If hGlobalMemory Then
			lpGlobalMemory = GlobalLock(hGlobalMemory)
			If lpGlobalMemory Then
				ret = lstrcpy(lpGlobalMemory, text)
				Call GlobalUnlock(hGlobalMemory)
				If OpenClipboard(hwnd) Then
					ret = EmptyClipboard()
					ret = SetClipboardData(CF_TEXT, hGlobalMemory)
					ret = CloseClipboard()
				End If
			Else
				Print "Clipboard: Can't allocated global memory pointer."
			End If
		Else
			Print "Clipboard: Can't allocated global memory handle."
		End If
	Else
		Print "Clipboard: Can't get window handle."
	End If
	
	Exit Sub
Errh:
	Call ErrHandler
	Exit Sub
End Sub